//
//  Observe.h
//  FinotesCore
//
//  Created by Don Peter on 12/8/17.
//  Copyright © 2017 BasilGregory Software Labs Pvt Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>

@interface Observer : NSObject



-(instancetype) severity:(int64_t) severity;
-(instancetype) expectNil:(Boolean) expectNil;
-(instancetype) expectedExecutionTime:(int32_t) expectedExecutionTime;
-(instancetype) expectedChainedExecutionTime:(int32_t) expectedChainedExecutionTime;
-(instancetype) min:(int64_t) min;
-(instancetype) max:(int64_t) max;
-(instancetype) mask:(NSArray *) maskParams;
-(instancetype) minDecimal:(double) minDecimal;
-(instancetype) maxDecimal:(double) maxDecimal;
-(instancetype) expectedBooleanValue:(Boolean) value;
-(instancetype) nextFunctionSignature:(SEL) nextFunctionSignature  inClass:(Class) nextObject;



-(Boolean) getExpectNil;
-(int32_t) getExpectedExecutionTime ;
-(int32_t) getExpectedChainedExecutionTime ;
-(int64_t) getSeverity;
-(int64_t) getMin ;
-(int64_t) getMax;
-(double) getMaxDecimal;
-(double) getMinDecimal;
-(Boolean) getExpectedBooleanValue;
-(SEL) getNextFunctionSignature;
-(Class) getNextObject ;
-(NSArray *) getMaskParams;

@end


